Index: palm/trunk/SOURCE/check_for_restart.f90
===================================================================
--- palm/trunk/SOURCE/check_for_restart.f90	(revision 4541)
+++ palm/trunk/SOURCE/check_for_restart.f90	(revision 4542)
@@ -1,20 +1,19 @@
 !> @file check_for_restart.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -25,6 +24,9 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Error messages revised
@@ -36,16 +38,13 @@
 ! Description:
 ! ------------
-!> Set stop flag, if restart is neccessary because of expiring cpu-time or
-!> if it is forced by user
-!------------------------------------------------------------------------------!
+!> Set stop flag, if restart is neccessary because of expiring cpu-time or if it is forced by user.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE check_for_restart
- 
-
-    USE control_parameters,                                                    &
-        ONLY:  coupling_mode, dt_restart, end_time, message_string,            &
-               run_description_header, simulated_time, terminate_coupled,      &
-               terminate_coupled_remote, terminate_run,                        &
-               termination_time_needed, time_restart,                          &
-               time_since_reference_point, write_binary
+
+
+    USE control_parameters,                                                                        &
+        ONLY:  coupling_mode, dt_restart, end_time, message_string, run_description_header,        &
+               simulated_time, terminate_coupled, terminate_coupled_remote, terminate_run,         &
+               termination_time_needed, time_restart, time_since_reference_point, write_binary
 
     USE kinds
@@ -53,5 +52,5 @@
     USE pegrid
 
-    USE pmc_interface,                                                         &
+    USE pmc_interface,                                                                             &
         ONLY:  comm_world_nesting, cpl_id, nested_run
 
@@ -80,6 +79,5 @@
 
 !
-!-- Set the global communicator to be used (depends on the mode in which PALM is
-!-- running)
+!-- Set the global communicator to be used (depends on the mode in which PALM is running)
     IF ( nested_run )  THEN
        global_communicator = comm_world_nesting
@@ -90,9 +88,9 @@
 #if defined( __parallel )
 !
-!-- Make a logical OR for all processes. Stop the model run if at least
-!-- one process has reached the time limit.
+!-- Make a logical OR for all processes. Stop the model run if at least one process has reached the
+!-- time limit.
     IF ( collective_wait )  CALL MPI_BARRIER( global_communicator, ierr )
-    CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL,     &
-                        MPI_LOR, global_communicator, ierr )
+    CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL, MPI_LOR,                   &
+                        global_communicator, ierr )
 #else
     terminate_run = terminate_run_l
@@ -102,17 +100,16 @@
 !-- Output that job will be terminated
     IF ( terminate_run  .AND.  myid == 0 )  THEN
-       WRITE( message_string, * ) 'run will be terminated because it is ',     &
-                       'running out of job cpu limit & ',                      &
-                       'remaining time:         ', remaining_time, ' s &',     &
-                       'termination time needed:', termination_time_needed, ' s'
+       WRITE( message_string, * ) 'run will be terminated because it is ',                         &
+                                  'running out of job cpu limit & ',                               &
+                                  'remaining time:         ', remaining_time, ' s &',              &
+                                  'termination time needed:', termination_time_needed, ' s'
        CALL message( 'check_for_restart', 'PA0163', 0, 1, 0, 6, 0 )
     ENDIF
 
 !
-!-- In case of coupled runs inform the remote model of the termination 
-!-- and its reason, provided the remote model has not already been 
-!-- informed of another termination reason (terminate_coupled > 0) before, 
-!-- or vice versa (terminate_coupled_remote > 0).
-    IF ( terminate_run .AND. TRIM( coupling_mode ) /= 'uncoupled'  .AND.       &
+!-- In case of coupled runs inform the remote model of the termination and its reason, provided the
+!-- remote model has not already been informed of another termination reason (terminate_coupled > 0)
+!-- before, or vice versa (terminate_coupled_remote > 0).
+    IF ( terminate_run .AND. TRIM( coupling_mode ) /= 'uncoupled'  .AND.                           &
          terminate_coupled == 0  .AND.  terminate_coupled_remote == 0 )  THEN
 
@@ -121,18 +118,17 @@
 #if defined( __parallel )
        IF ( myid == 0 ) THEN
-          CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,         &
-                             target_id, 0,                                     &
-                             terminate_coupled_remote, 1, MPI_INTEGER,         &
-                             target_id, 0,                                     &
+          CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,                             &
+                             target_id, 0,                                                         &
+                             terminate_coupled_remote, 1, MPI_INTEGER,                             &
+                             target_id, 0,                                                         &
                              comm_inter, status, ierr )
        ENDIF
-       CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d,    &
-                       ierr )
-#endif
-    ENDIF
-
-
-!
-!-- Check if a flag file exists that forces a termination of the model
+       CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr )
+#endif
+    ENDIF
+
+
+!
+!-- Check if a flag file exists that forces a termination of the model.
     IF ( myid == 0 )  THEN
        INQUIRE(FILE="DO_STOP_NOW", EXIST=do_stop_now)
@@ -143,9 +139,9 @@
           terminate_run_l = .TRUE.
 
-          WRITE( message_string, * ) 'run will be terminated because user ',   &
-                                  'forced a job finalization using a flag',    &
-                                  'file:',                                     &
-                                  '&DO_STOP_NOW: ', do_stop_now,               &
-                                  '&DO_RESTART_NOW: ', do_restart_now 
+          WRITE( message_string, * ) 'run will be terminated because user ',                       &
+                                     'forced a job finalization using a flag',                     &
+                                     'file:',                                                      &
+                                     '&DO_STOP_NOW: ', do_stop_now,                                &
+                                     '&DO_RESTART_NOW: ', do_restart_now
           CALL message( 'check_for_restart', 'PA0398', 0, 0, 0, 6, 0 )
 
@@ -156,9 +152,8 @@
 #if defined( __parallel )
 !
-!-- Make a logical OR for all processes. Stop the model run if a flag file has
-!-- been detected above.
+!-- Make a logical OR for all processes. Stop the model run if a flag file has been detected above.
     IF ( collective_wait )  CALL MPI_BARRIER( global_communicator, ierr )
-    CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL,        &
-                        MPI_LOR, global_communicator, ierr )
+    CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL, MPI_LOR,                   &
+                        global_communicator, ierr )
 #else
     terminate_run = terminate_run_l
@@ -166,9 +161,8 @@
 
 !
-!-- In case of coupled runs inform the remote model of the termination 
-!-- and its reason, provided the remote model has not already been 
-!-- informed of another termination reason (terminate_coupled > 0) before,
-!-- or vice versa (terminate_coupled_remote > 0).
-    IF ( terminate_run .AND. coupling_mode /= 'uncoupled' .AND.                &
+!-- In case of coupled runs inform the remote model of the termination and its reason, provided the
+!-- remote model has not already been informed of another termination reason (terminate_coupled > 0)
+!-- before, or vice versa (terminate_coupled_remote > 0).
+    IF ( terminate_run .AND. coupling_mode /= 'uncoupled' .AND.                                    &
          terminate_coupled == 0 .AND.  terminate_coupled_remote == 0 )  THEN
 
@@ -177,12 +171,11 @@
 #if defined( __parallel )
        IF ( myid == 0 ) THEN
-          CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,      &
-                             target_id,  0,                                 &
-                             terminate_coupled_remote, 1, MPI_INTEGER,      &
-                             target_id,  0,                                 &
-                             comm_inter, status, ierr )   
-       ENDIF
-       CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0,         &
-                       comm2d, ierr )  
+          CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,                             &
+                             target_id,  0,                                                        &
+                             terminate_coupled_remote, 1, MPI_INTEGER,                             &
+                             target_id,  0,                                                        &
+                             comm_inter, status, ierr )
+       ENDIF
+       CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr )
 #endif
 
@@ -191,15 +184,13 @@
 !
 !-- Set the stop flag also, if restart is forced by user settings
-    IF ( time_restart /= 9999999.9_wp  .AND.                                   &
-         time_restart < time_since_reference_point )  THEN
-
-!
-!--    Restart is not neccessary, if the end time of the run (given by
-!--    the user) has been reached
+    IF ( time_restart /= 9999999.9_wp  .AND.  time_restart < time_since_reference_point )  THEN
+
+!
+!--    Restart is not neccessary, if the end time of the run (given by the user) has been reached.
        IF ( simulated_time < end_time )  THEN
           terminate_run = .TRUE.
 !
-!--       Increment restart time, if forced by user, otherwise set restart
-!--       time to default (no user restart)
+!--       Increment restart time, if forced by user, otherwise set restart time to default (no user
+!--       restart).
           IF ( dt_restart /= 9999999.9_wp )  THEN
              time_restart = time_restart + dt_restart
@@ -208,16 +199,15 @@
           ENDIF
 
-          WRITE( message_string, * ) 'run will be terminated due to user ',    &
-                                  'settings of ',                              &
-                                  'restart_time / dt_restart, ',               &
-                                  'new restart time is: ', time_restart, ' s' 
+          WRITE( message_string, * ) 'run will be terminated due to user ',                        &
+                                     'settings of ',                                               &
+                                     'restart_time / dt_restart, ',                                &
+                                     'new restart time is: ', time_restart, ' s'
           CALL message( 'check_for_restart', 'PA0164', 0, 0, 0, 6, 0 )
- 
-!
-!--       In case of coupled runs inform the remote model of the termination 
-!--       and its reason, provided the remote model has not already been 
-!--       informed of another termination reason (terminate_coupled > 0) before,
-!--       or vice versa (terminate_coupled_remote > 0).
-          IF ( coupling_mode /= 'uncoupled' .AND. terminate_coupled == 0       &
+
+!
+!--       In case of coupled runs inform the remote model of the termination and its reason,
+!--       provided the remote model has not already been informed of another termination reason
+!--       (terminate_coupled > 0) before, or vice versa (terminate_coupled_remote > 0).
+          IF ( coupling_mode /= 'uncoupled' .AND. terminate_coupled == 0                           &
                .AND.  terminate_coupled_remote == 0 )  THEN
 
@@ -229,12 +219,11 @@
 #if defined( __parallel )
              IF ( myid == 0 ) THEN
-                CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,   &
-                                   target_id,  0,                              &
-                                   terminate_coupled_remote, 1, MPI_INTEGER,   &
-                                   target_id,  0,                              &
-                                   comm_inter, status, ierr )   
+                CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,                       &
+                                   target_id,  0,                                                  &
+                                   terminate_coupled_remote, 1, MPI_INTEGER,                       &
+                                   target_id,  0,                                                  &
+                                   comm_inter, status, ierr )
              ENDIF
-             CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0,      &
-                             comm2d, ierr )  
+             CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr )
 #endif
           ENDIF
@@ -245,9 +234,7 @@
 
 !
-!-- If the run is stopped, set a flag file which is necessary to initiate
-!-- the start of a continuation run, except if the user forced to stop the
-!-- run without restart
-    IF ( terminate_run  .AND.  myid == 0  .AND.  cpl_id == 1  .AND.            &
-         .NOT. do_stop_now)  THEN
+!-- If the run is stopped, set a flag file which is necessary to initiate the start of a
+!-- continuation run, except if the user forced to stop the run without restart.
+    IF ( terminate_run  .AND.  myid == 0  .AND.  cpl_id == 1  .AND.  .NOT. do_stop_now)  THEN
 
        OPEN ( 90, FILE='CONTINUE_RUN', FORM='FORMATTED' )
Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4541)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4542)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! redundant if statement removed
+! 
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
 ! 
@@ -3062,6 +3065,4 @@
 
 
-    CHARACTER (LEN=20) :: spc_name_av !<   
-
     INTEGER(iwp) ::  lsp             !<
     INTEGER(iwp) ::  k               !< 
@@ -3087,31 +3088,23 @@
 
 
-    IF ( ALLOCATED( chem_species ) )  THEN
-
-       DO  lsp = 1, nspec
-
-          !< for time-averaged chemical conc.
-          spc_name_av  =  TRIM( chem_species(lsp)%name )//'_av'
-
-          IF ( restart_string(1:length) == TRIM( chem_species(lsp)%name) )    &
-             THEN
-             !< read data into tmp_3d
-             IF ( k == 1 )  READ ( 13 )  tmp_3d  
-             !< fill ..%conc in the restart run    
-             chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,                    &
-                  nxlc-nbgp:nxrc+nbgp) =                  & 
-                  tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-             found = .TRUE.
-          ELSEIF (restart_string(1:length) == spc_name_av )  THEN
-             IF ( k == 1 )  READ ( 13 )  tmp_3d
-             chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,                 &
-                  nxlc-nbgp:nxrc+nbgp) =               &
-                  tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-             found = .TRUE.
-          ENDIF
-
-       ENDDO
-
-    ENDIF
+    DO  lsp = 1, nspec
+
+       IF ( restart_string(1:length) == TRIM( chem_species(lsp)%name) )  THEN
+
+          IF ( k == 1 )  READ ( 13 )  tmp_3d
+          chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                      &
+                                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+          found = .TRUE.
+
+       ELSEIF (restart_string(1:length) == TRIM( chem_species(lsp)%name ) // '_av' )  THEN
+
+          IF ( k == 1 )  READ ( 13 )  tmp_3d
+          chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                   &
+                                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+          found = .TRUE.
+
+       ENDIF
+
+    ENDDO
 
 
@@ -3128,16 +3121,13 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  lsp !<
-
-    IF ( ALLOCATED( chem_species ) )  THEN
-
-       DO  lsp = 1, nspec
-
-          CALL rrd_mpi_io( TRIM( chem_species(lsp)%name ), chem_species(lsp)%conc )
-          CALL rrd_mpi_io( TRIM( chem_species(lsp)%name )//'_av', chem_species(lsp)%conc_av )
-
-       ENDDO
-
-    ENDIF
+    INTEGER(iwp) ::  lsp  !<
+
+
+    DO  lsp = 1, nspec
+
+       CALL rrd_mpi_io( TRIM( chem_species(lsp)%name ), chem_species(lsp)%conc )
+       CALL rrd_mpi_io( TRIM( chem_species(lsp)%name )//'_av', chem_species(lsp)%conc_av )
+
+    ENDDO
 
  END SUBROUTINE chem_rrd_local_mpi
